(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define("AsyncFetcher", ["exports", "babel-runtime/helpers/defineProperty", "babel-runtime/core-js/object/keys", "babel-runtime/helpers/typeof", "babel-runtime/helpers/extends", "babel-runtime/core-js/object/get-prototype-of", "babel-runtime/helpers/classCallCheck", "babel-runtime/helpers/createClass", "babel-runtime/helpers/possibleConstructorReturn", "babel-runtime/helpers/inherits", "react", "prop-types", "axios", "lodash.debounce", "lodash.isplainobject", "fast-deep-equal", "./utils"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require("babel-runtime/helpers/defineProperty"), require("babel-runtime/core-js/object/keys"), require("babel-runtime/helpers/typeof"), require("babel-runtime/helpers/extends"), require("babel-runtime/core-js/object/get-prototype-of"), require("babel-runtime/helpers/classCallCheck"), require("babel-runtime/helpers/createClass"), require("babel-runtime/helpers/possibleConstructorReturn"), require("babel-runtime/helpers/inherits"), require("react"), require("prop-types"), require("axios"), require("lodash.debounce"), require("lodash.isplainobject"), require("fast-deep-equal"), require("./utils"));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.defineProperty, global.keys, global._typeof, global._extends, global.getPrototypeOf, global.classCallCheck, global.createClass, global.possibleConstructorReturn, global.inherits, global.react, global.propTypes, global.axios, global.lodash, global.lodash, global.fastDeepEqual, global.utils);
    global.AsyncFetcher = mod.exports;
  }
})(this, function (exports, _defineProperty2, _keys, _typeof2, _extends2, _getPrototypeOf, _classCallCheck2, _createClass2, _possibleConstructorReturn2, _inherits2, _react, _propTypes, _axios, _lodash, _lodash3, _fastDeepEqual, _utils) {
  "use strict";

  Object.defineProperty(exports, "__esModule", {
    value: true
  });

  var _defineProperty3 = _interopRequireDefault(_defineProperty2);

  var _keys2 = _interopRequireDefault(_keys);

  var _typeof3 = _interopRequireDefault(_typeof2);

  var _extends3 = _interopRequireDefault(_extends2);

  var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

  var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

  var _createClass3 = _interopRequireDefault(_createClass2);

  var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

  var _inherits3 = _interopRequireDefault(_inherits2);

  var _propTypes2 = _interopRequireDefault(_propTypes);

  var _axios2 = _interopRequireDefault(_axios);

  var _lodash2 = _interopRequireDefault(_lodash);

  var _lodash4 = _interopRequireDefault(_lodash3);

  var _fastDeepEqual2 = _interopRequireDefault(_fastDeepEqual);

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }

  var defaultFetchCreator = function defaultFetchCreator(requestData) {
    return (0, _axios2.default)(requestData);
  };

  var AsyncFetcher = function (_PureComponent) {
    (0, _inherits3.default)(AsyncFetcher, _PureComponent);

    function AsyncFetcher(props) {
      (0, _classCallCheck3.default)(this, AsyncFetcher);

      var _this = (0, _possibleConstructorReturn3.default)(this, (AsyncFetcher.__proto__ || (0, _getPrototypeOf2.default)(AsyncFetcher)).call(this, props));

      _this.fetch = function () {
        var dataEvent = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
        var customRequest = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
        var _this$props = _this.props,
            url = _this$props.url,
            headers = _this$props.headers,
            axiosConfig = _this$props.axiosConfig,
            authToken = _this$props.authToken,
            ajax = _this$props.ajax,
            accepts = _this$props.accepts,
            responseType = _this$props.responseType,
            withCredentials = _this$props.withCredentials,
            transformError = _this$props.transformError,
            fetchCreator = _this$props.fetchCreator,
            onResponse = _this$props.onResponse,
            onError = _this$props.onError;


        var method = _this.props.method.toLowerCase();
        var isPost = method === "post" || method === "put";
        var isEventData = !!dataEvent && (0, _utils.isEvent)(dataEvent);

        var contentType = !!_this.props.contentType ? (0, _utils.parseMime)(_this.props.contentType) : isPost ? (0, _utils.parseMime)("form") : null;

        var customHeaders = {};
        if (!!contentType) {
          customHeaders["Content-Type"] = contentType;
        }
        if (!!authToken) {
          var authorization = typeof authToken === "function" ? authToken() : authToken;
          if (!!authorization) {
            if (authorization.indexOf("Bearer") === -1) {
              authorization = "Bearer " + authorization;
            }
            customHeaders["Authorization"] = authorization;
          }
        }
        if (!!ajax) {
          customHeaders["X-Requested-With"] = "XMLHttpRequest";
        }
        if (!!accepts) {
          customHeaders["Accept"] = function () {
            if (typeof accepts === "string") {
              return accepts.split(";").map(_utils.parseMime).join(";");
            }
            if (Array.isArray(accepts)) {
              return accepts.map(_utils.parseMime).join(";");
            }
            if (typeof accepts === "function") {
              return accepts();
            }
            return accepts;
          }();
        }

        var requestConfig = {
          method: method,
          withCredentials: !!withCredentials,
          headers: (0, _extends3.default)({}, headers, customHeaders)
        };

        var params = !isPost && !!dataEvent && !isEventData ? dataEvent : (0, _utils.concatParams)(_this.props.params, _this.state.params);

        if (typeof url === "function") {
          requestConfig.url = url(!!params ? params : {});
        } else {
          requestConfig.url = url;

          if (!!params) {
            if (typeof params !== "string" && (0, _lodash4.default)(params)) {
              params = (0, _utils.serialize)(params);
            }
            if (typeof params === "string") {
              requestConfig.url = (requestConfig.url + (requestConfig.url.indexOf("?") === -1 ? "?" : "&") + params).replace(/\?&/gi, "?");
            } else {
              requestConfig.params = params;
            }
          }
        }

        if (isPost) {
          var data = !!dataEvent && !isEventData ? dataEvent : (0, _utils.concatParams)(_this.props.postData, _this.state.postData);
          if (!!data && contentType.indexOf("x-www-form-urlencoded") !== -1 && (0, _lodash4.default)(data)) {
            data = (0, _utils.serialize)(data);
          }
          requestConfig.data = data;
        }

        if (!!responseType) {
          requestConfig.responseType = responseType;
        }

        _this.setState({ isLoading: true, error: null }, function () {
          return fetchCreator((0, _extends3.default)({}, requestConfig, axiosConfig, customRequest)).then(function (response) {
            if (!_this._mounted) {
              return;
            }

            _this.setState({
              response: response,
              data: response.data,
              isLoading: false
            }, function () {
              if (!!onResponse) onResponse(response);
            });
          }).catch(function (error) {
            if (!_this._mounted) {
              return;
            }

            var transformedError = transformError((0, _extends3.default)({}, error));

            _this.setState(function () {
              var errorState = {
                error: "" + (!!transformedError && typeof transformedError === "string" ? transformedError : error),
                response: null,
                data: null,
                isLoading: false
              };
              if (!!transformedError && (typeof transformedError === "undefined" ? "undefined" : (0, _typeof3.default)(transformedError)) === "object" && "response" in transformedError) {
                errorState.response = transformedError.response;

                if (!!errorState.response && (0, _typeof3.default)(errorState.response) === "object" && "data" in errorState.response) {
                  errorState.data = errorState.response.data;
                }
              }

              return errorState;
            }, function () {
              if (!!onError) onError(transformedError);
            });
          });
        });
      };

      _this.setCustomState = function (state) {
        if (!!state && ((typeof state === "undefined" ? "undefined" : (0, _typeof3.default)(state)) === "object" || typeof state === "function")) {
          var hasCustom = false;
          var customState = _this.state.customState;

          if (typeof state === "function") {
            state = state((0, _extends3.default)({
              params: _this.state.params,
              postData: _this.state.postData
            }, customState));
            if ((typeof state === "undefined" ? "undefined" : (0, _typeof3.default)(state)) !== "object") {
              return;
            }
          }

          (0, _keys2.default)(state).forEach(function (k) {
            if (["params", "postData", "data"].indexOf(k) !== -1) {
              if (!(0, _fastDeepEqual2.default)(_this.state[k], state[k])) {
                _this.setState((0, _defineProperty3.default)({}, k, state[k]));
              }
            } else {
              customState[k] = state[k];
              hasCustom = true;
            }
          });

          if (hasCustom) {
            _this.setState({ customState: customState });
          }
        }
      };

      _this._mounted = false;


      _this._debouncedFetch = +props.debounce > 0 ? (0, _lodash2.default)(_this.fetch.bind(_this), +props.debounce) : _this.fetch.bind(_this);

      _this.state = {
        isLoading: !!props.autoFetch,
        response: null,
        data: null,
        error: null,
        params: null,
        postData: null,
        customState: {}
      };
      return _this;
    }

    (0, _createClass3.default)(AsyncFetcher, [{
      key: "componentDidUpdate",
      value: function componentDidUpdate(prevProps, prevState) {
        var _this2 = this;

        var hasChange = false;
        ["method", "params", "postData", "url", "authToken"].forEach(function (k) {
          if (k in prevProps && !(0, _fastDeepEqual2.default)(prevProps[k], _this2.props[k])) {
            hasChange = true;
          }
        });
        if (!hasChange) {
          ["params", "postData"].forEach(function (k) {
            if (k in prevState && !(0, _fastDeepEqual2.default)(prevState[k], _this2.state[k])) {
              hasChange = true;
            }
          });
        }

        if (+prevProps.debounce !== +this.props.debounce) {
          this._debouncedFetch = +this.props.debounce > 0 ? (0, _lodash2.default)(this.fetch.bind(this), +this.props.debounce) : this.fetch.bind(this);
        }

        if (hasChange && !!this.props.autoFetch) {
          this._debouncedFetch();
        }
      }
    }, {
      key: "componentDidMount",
      value: function componentDidMount() {
        this._mounted = true;

        if (!!this.props.autoFetch) {
          this.fetch();
        }
      }
    }, {
      key: "componentWillUnmount",
      value: function componentWillUnmount() {
        this._mounted = false;
      }
    }, {
      key: "render",
      value: function render() {
        if (!!this.props.children && typeof this.props.children === "function") {
          return this.props.children({
            fetch: this.fetch,
            isLoading: this.state.isLoading,
            response: this.state.response,
            data: this.state.data,
            error: this.state.error,
            params: (0, _utils.concatParams)(this.props.params, this.state.params),
            postData: (0, _utils.concatParams)(this.props.postData, this.state.postData),
            state: this.state.customState,
            set: this.setCustomState
          }) || null;
        }

        return null;
      }
    }]);
    return AsyncFetcher;
  }(_react.PureComponent);

  AsyncFetcher.propTypes = {
    autoFetch: _propTypes2.default.bool,
    method: _propTypes2.default.oneOf(["get", "post", "put", "delete", "options"]),
    url: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.func]).isRequired,
    params: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.object]),
    postData: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.object]),
    headers: _propTypes2.default.object,
    axiosConfig: _propTypes2.default.object,
    ajax: _propTypes2.default.bool,
    authToken: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.func]),
    accepts: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.array]),
    contentType: _propTypes2.default.string,
    responseType: _propTypes2.default.string,
    withCredentials: _propTypes2.default.bool,
    transformError: _propTypes2.default.func,
    fetchCreator: _propTypes2.default.func,
    onResponse: _propTypes2.default.func,
    onError: _propTypes2.default.func,
    debounce: _propTypes2.default.number,
    children: _propTypes2.default.func
  };
  AsyncFetcher.defaultProps = {
    autoFetch: true,
    method: "get",
    headers: {},
    axiosConfig: {},
    ajax: false,
    withCredentials: false,
    transformError: function transformError(err) {
      return err;
    },
    fetchCreator: defaultFetchCreator,
    debounce: 0
  };
  exports.default = AsyncFetcher;
});